<?php

class SharedFilesAdminMaintenance {

  public function update_db_check() {

    $s = get_option('shared_files_settings');

    if (!get_option('shared-files-sc')) {

      $rand_code = sanitize_text_field( md5(uniqid(rand(), true)) );

      add_option('shared-files-sc', $rand_code, '', 'yes');

    }

//    wp_clear_scheduled_hook('check_expired_files');
//    wp_clear_scheduled_hook('cron_sync_folders_and_files');
//    wp_clear_scheduled_hook('cron_remove_obsolete_file_metadata_automatically');

    if (!wp_next_scheduled('check_expired_files')) {
      wp_schedule_event(time(), 'daily', 'check_expired_files');
    }

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if (!wp_next_scheduled('cron_sync_folders_and_files')) {
          wp_schedule_event(time(), 'every_15_min', 'cron_sync_folders_and_files');
        }

        if ( isset($s['remove_obsolete_file_metadata_automatically']) && $s['remove_obsolete_file_metadata_automatically'] ) {

          if (!wp_next_scheduled('cron_remove_obsolete_file_metadata_automatically')) {
            wp_schedule_event(time(), 'every_15_min', 'cron_remove_obsolete_file_metadata_automatically');
          }

        } elseif ( wp_next_scheduled('cron_remove_obsolete_file_metadata_automatically') ) {

          wp_clear_scheduled_hook('cron_remove_obsolete_file_metadata_automatically');

        }

      }

    }


//    wp_die(wp_next_scheduled('cron_remove_obsolete_file_metadata_automatically'));

//    delete_option('shared_files_settings');

    if ($s === false) {

//      register_setting('shared-files', 'shared_files_settings');

      $wp_subdir = SharedFilesHelpers::getWPSubdir();

      $default_settings = [
        'hide_bandwidth_usage'          => 'on',
        'card_background'               => 'light_gray',
        'preview_service'               => 'microsoft',
        'uncheck_hide_from_other_pages' => 'on',
        'always_preview_pdf'            => 'on',
        'bypass_preview_pdf'            => 'on',
        'pagination_type'               => 'improved',
        'wp_engine_compatibility_mode'  => 'on',
        'show_file_upload_checkboxes_on_multiple_columns' => 'on',
        'show_download_button'          => 'on',
        'show_download_counter'         => 'on',
        'simple_list_show_titles_for_columns'  => 'on',
        'simple_list_show_download_counter' => 'on',
        'simple_list_show_tag'          => 'on',
        'tag_slug'                      => 'shared-file-tag',
        'log_enable_user_data'          => 'on',
        'log_enable_ip'                 => 'on',
        'log_enable_user_agent'         => 'on',
        'log_enable_referer_url'        => 'on',
        'prevent_search_engines_from_indexing_uploaded_file_urls' => 'on',
        'show_tag_dropdown_on_file_upload'  => 'on',
        'lead_show_name'                => 'on',
        'lead_show_phone'               => 'on',
        'lead_show_description'         => 'on',
        'wp_location'                   => $wp_subdir,
      ];

      add_option('shared_files_settings', $default_settings);

      update_option('shared_files_how_to_show_notice', 1, false);

    }

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if ( isset($s['file_sync_interval']) && $s['file_sync_interval'] ) {

          $s_current_interval = sanitize_text_field( $s['file_sync_interval'] );
          $file_sync_interval_event = wp_get_scheduled_event('cron_sync_folders_and_files');

          if ( isset($file_sync_interval_event->schedule) && $cron_current_interval = $file_sync_interval_event->schedule ) {

            if ($cron_current_interval == 'every_min' &&
                $s_current_interval    != 'every_min') {

              wp_clear_scheduled_hook('cron_sync_folders_and_files');

              if (!wp_next_scheduled('cron_sync_folders_and_files')) {
                wp_schedule_event(time(), $s_current_interval, 'cron_sync_folders_and_files');
              }

            } elseif ($cron_current_interval == 'shared_files_every_5_min' &&
                      $s_current_interval    != 'shared_files_every_5_min') {

              wp_clear_scheduled_hook('cron_sync_folders_and_files');

              if (!wp_next_scheduled('cron_sync_folders_and_files')) {
                wp_schedule_event(time(), $s_current_interval, 'cron_sync_folders_and_files');
              }

            } elseif ($cron_current_interval == 'every_15_min' &&
                      $s_current_interval    != '' &&
                      $s_current_interval    != 'every_15_min') {

              wp_clear_scheduled_hook('cron_sync_folders_and_files');

              if (!wp_next_scheduled('cron_sync_folders_and_files')) {
                wp_schedule_event(time(), $s_current_interval, 'cron_sync_folders_and_files');
              }

            }

          }

          $remove_file_metadata_interval_event = wp_get_scheduled_event('cron_remove_obsolete_file_metadata_automatically');

          if ( isset($remove_file_metadata_interval_event->schedule) && $cron_current_interval = $remove_file_metadata_interval_event->schedule ) {

            if ($cron_current_interval == 'every_min' &&
                $s_current_interval    != 'every_min') {

              wp_clear_scheduled_hook('cron_remove_obsolete_file_metadata_automatically');

              if (!wp_next_scheduled('cron_remove_obsolete_file_metadata_automatically')) {
                wp_schedule_event(time(), $s_current_interval, 'cron_remove_obsolete_file_metadata_automatically');
              }

            } elseif ($cron_current_interval == 'shared_files_every_5_min' &&
                      $s_current_interval    != 'shared_files_every_5_min') {

              wp_clear_scheduled_hook('cron_remove_obsolete_file_metadata_automatically');

              if (!wp_next_scheduled('cron_remove_obsolete_file_metadata_automatically')) {
                wp_schedule_event(time(), $s_current_interval, 'cron_remove_obsolete_file_metadata_automatically');
              }

            } elseif ($cron_current_interval == 'every_15_min' &&
                      $s_current_interval    != '' &&
                      $s_current_interval    != 'every_15_min') {

              wp_clear_scheduled_hook('cron_remove_obsolete_file_metadata_automatically');

              if (!wp_next_scheduled('cron_remove_obsolete_file_metadata_automatically')) {
                wp_schedule_event(time(), $s_current_interval, 'cron_remove_obsolete_file_metadata_automatically');
              }

            }

          }

        }

      }
    }

  }

  public function update_db_check_v2() {

    $installed_version = get_option('shared_files_version');

    if ($installed_version != SHARED_FILES_VERSION) {

      global $wpdb;

      $charset_collate = $wpdb->get_charset_collate();

      // Table for debug data and general log
      $table_name_log = $wpdb->prefix . 'shared_files_log';

      $wpdb->query("CREATE TABLE IF NOT EXISTS " . $table_name_log . " (
        id              BIGINT(20) NOT NULL auto_increment,
        title           VARCHAR(255) NOT NULL,
        message         TEXT NOT NULL,
        created_at      TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
        PRIMARY KEY (id)
      ) " . $charset_collate . ";" );

      // Table for file download log
      $table_name_download_log = $wpdb->prefix . 'shared_files_download_log';

      $wpdb->query("CREATE TABLE IF NOT EXISTS " . $table_name_download_log . " (
        id              BIGINT(20) NOT NULL auto_increment,
        file_id         VARCHAR(255) NOT NULL,
        file_title      VARCHAR(255) NOT NULL,
        file_name       VARCHAR(255) NOT NULL,
        file_size       VARCHAR(255) NOT NULL,
        ip              VARCHAR(255) NOT NULL,
        download_cnt    MEDIUMINT NOT NULL,
        report          TEXT NOT NULL,
        created_at      TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
        user_id         BIGINT(20) NOT NULL,
        user_login      VARCHAR(255) NOT NULL,
        user_name       VARCHAR(255) NOT NULL,
        user_country    VARCHAR(255) NOT NULL,
        user_agent      TEXT NOT NULL,
        referer_url     TEXT NOT NULL,
        PRIMARY KEY (id)
      ) " . $charset_collate . ";" );

      $column_exists = $wpdb->get_results( "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE table_name = '" . $table_name_download_log . "' AND column_name = 'user_id'" );

      if ( !$column_exists ) {
        $wpdb->query("ALTER TABLE $table_name_download_log " .
                      "ADD user_id      BIGINT(20) NOT NULL, " .
                      "ADD user_login   VARCHAR(255) NOT NULL, " .
                      "ADD user_name    VARCHAR(255) NOT NULL, " .
                      "ADD user_country VARCHAR(255) NOT NULL, " .
                      "ADD user_agent   TEXT NOT NULL, " .
                      "ADD referer_url  TEXT NOT NULL "
                    );
      }

      // Table for contacts
      $table_name_contacts = $wpdb->prefix . 'shared_files_contacts';

      $wpdb->query("CREATE TABLE IF NOT EXISTS " . $table_name_contacts . " (
        id                BIGINT(20) NOT NULL auto_increment,
        file_id           VARCHAR(255) NOT NULL,
        file_title        VARCHAR(255) NOT NULL,
        file_name         VARCHAR(255) NOT NULL,
        file_size         VARCHAR(255) NOT NULL,
        embed_id          VARCHAR(255) NOT NULL,
        ask_for_email_id  VARCHAR(255) NOT NULL,
        email             VARCHAR(255) NOT NULL,
        ip                VARCHAR(255) NOT NULL,
        user_country      VARCHAR(255) NOT NULL,
        user_agent        TEXT NOT NULL,
        referer_url       TEXT NOT NULL,
        title             VARCHAR(255) NOT NULL,
        message           TEXT NOT NULL,
        created_at        TIMESTAMP DEFAULT CURRENT_TIMESTAMP,
        name              VARCHAR(255) NOT NULL,
        phone             VARCHAR(255) NOT NULL,
        descr             TEXT NOT NULL,
        PRIMARY KEY (id)
      ) " . $charset_collate . ";" );


      $column_exists = $wpdb->get_results( "SELECT COLUMN_NAME FROM INFORMATION_SCHEMA.COLUMNS WHERE table_name = '" . $table_name_contacts . "' AND column_name = 'name'" );

      if ( !$column_exists ) {
        $wpdb->query("ALTER TABLE $table_name_contacts " .
                      "ADD name   VARCHAR(255) NOT NULL, " .
                      "ADD phone  VARCHAR(255) NOT NULL, " .
                      "ADD descr  TEXT NOT NULL "
                    );
      }


      update_option('shared_files_version', SHARED_FILES_VERSION);

      SharedFilesHelpers::writeLog('Plugin updated to version ' . SHARED_FILES_VERSION, '');

      $sf_dir = wp_get_upload_dir()['basedir'] . '/shared-files/';
      $sf_file = $sf_dir . 'index.php';

      if ( !file_exists( $sf_dir ) || !is_dir( $sf_dir ) ) {

        mkdir( $sf_dir );

        if ( is_dir( $sf_dir ) ) {
          SharedFilesHelpers::writeLog( 'Created ' . $sf_dir, '' );
        }

      }

      if (is_dir($sf_dir) && !file_exists($sf_file) && $file = fopen($sf_file, 'a')) {

        fwrite($file, '<?php // Automatically generated by Shared Files ?>' . PHP_EOL);
        fclose($file);

      }

      $sf_dir = wp_get_upload_dir()['basedir'] . '/shared-files/_export/';
      $sf_file = $sf_dir . 'index.php';

      if ( !file_exists( $sf_dir ) || !is_dir( $sf_dir ) ) {

        mkdir( $sf_dir );

        if ( is_dir( $sf_dir ) ) {
          SharedFilesHelpers::writeLog( 'Created ' . $sf_dir, '' );
        }

      }

      if (is_dir($sf_dir) && !file_exists($sf_file) && $file = fopen($sf_file, 'a')) {

        fwrite($file, '<?php // Automatically generated by Shared Files ?>' . PHP_EOL);
        fclose($file);

      }

      if (shared_files_fs()->is__premium_only()) {
        if (shared_files_fs()->can_use_premium_code()) {

          // START METADATA UPDATE

          $shared_files_subdir_fixed = get_option('shared_files_subdir_fixed');

          if (!$shared_files_subdir_fixed) {

            SharedFilesHelpers::writeLog('START file metadata update check (subdir fix)', '');

            update_option('shared_files_subdir_fixed', 1);

            $wp_query = new WP_Query(array(
              'post_type'       => 'shared_file',
              'post_status'     => 'publish',
              'posts_per_page'  => -1,
            ));

            $cnt = 0;
            $bypass_cnt = 0;

            if ($wp_query->have_posts()) {

              while ($wp_query->have_posts()) {

                $wp_query->the_post();

                $id = intval( get_the_id() );

                $file = get_post_meta($id, '_sf_file', true);
                $folder_name = sanitize_file_name( get_post_meta($id, '_sf_subdir', true) );

                $filename_with_path = '';

                // filename with absolute path on server
                if (isset( $file['file'] )) {
                  $filename_with_path = $file['file'];
                }

                if ($filename_with_path) {

                  $item_array = explode('/', $filename_with_path);
                  $item_array_sliced = array_slice($item_array, -2, 2);
                  $subdir = '';

                  if (is_array($item_array_sliced) && $item_array_sliced[0] == 'shared-files') {

                    \array_splice($item_array_sliced, 0, 1);

                  } elseif (is_array($item_array_sliced)) {

                    $subdir = $item_array_sliced[0];

                  }

                  if ($subdir && !$folder_name) {

                    SharedFilesHelpers::writeLog('Subdir detected, no _sf_subdir set (ID ' . $id . '): ' . sanitize_text_field( $filename_with_path ), '');
                    SharedFilesHelpers::writeLog('Save to _sf_subdir: ' . sanitize_text_field( $subdir ), '');
                    update_post_meta($id, '_sf_subdir', sanitize_text_field( $subdir ) );

                    $cnt++;

                  } else {
//                    SharedFilesHelpers::writeLog('Bypass: ' . $filename_with_path, '');
//                    update_post_meta($id, '_sf_subdir', '' );
                    $bypass_cnt++;
                  }

                }

              }

              wp_reset_postdata();

            }

            SharedFilesHelpers::writeLog('_sf_subdir updated (not empty): ' . sanitize_text_field( $cnt ) . ' files', '');
            SharedFilesHelpers::writeLog('_sf_subdir empty or already set: ' . sanitize_text_field( $bypass_cnt ) . ' files', '');

            SharedFilesHelpers::writeLog('END file metadata update check (subdir fix)', '');

          }

          // END METADATA UPDATE

        }
      }

    }

  }

  public function add_cron_interval($schedules) {

    $schedules['every_min'] = array(
      'interval'  => 60, // time in seconds
      'display'   => 'Every minute'
    );

    $schedules['every_15_min'] = array(
      'interval'  => 900, // time in seconds
      'display'   => 'Every 15 minutes'
    );

    $schedules['shared_files_every_5_min'] = array(
      'interval'  => 300, // time in seconds
      'display'   => 'Every 5 minutes'
    );

    return $schedules;
  }

}
