<?php

class SharedFilesAdminMultipleFilesUpload {

  public function file_upload() {

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if (isset($_POST) && isset($_POST['_sf_insert_multiple_files'])) {
    
          $num = sizeof($_FILES['_sf_files']['name']);
          
          for ($i = 0; $i < $num; $i++) {
    
            $filename = $_FILES['_sf_files']['name'][$i];
     
            if (isset($_FILES['_sf_files']['tmp_name'][$i]) && $tmp_name = $_FILES['_sf_files']['tmp_name'][$i]) {
    
              if (!isset($_POST['secret_code']) || !wp_verify_nonce($_POST['secret_code'], 'sf_insert_multiple_files')) {
                wp_die('Error in processing form data.');
              }
      
              $new_post = array( 'post_type'    => 'shared_file',
                                 'post_status'  => 'publish',
                                 'post_title'   => '', 
                                 'post_content' => '');
              
              $id = wp_insert_post($new_post);
    
              update_post_meta($id, '_sf_description', '');
    
              if (isset($_POST['shared-file-category']) && $_POST['shared-file-category']) {
                wp_set_object_terms($id, $_POST['shared-file-category'], 'shared-file-category');
              }
      
              // Get the file type of the upload
              $arr_file_type = wp_check_filetype(basename($_FILES['_sf_files']['name'][$i]));
              $uploaded_type = $arr_file_type['type'];

              $file_contents_sanitized = SharedFilesAdminAllowMoreFileTypes::sanitize_file( $tmp_name );
      
              add_filter('upload_dir', [ $this, 'set_upload_dir' ]);
              add_filter('upload_mimes', [ 'SharedFilesAdminAllowMoreFileTypes', 'add_file_types' ] );
      
              // Use the WordPress API to upload the file
              $upload = wp_upload_bits($_FILES['_sf_files']['name'][$i], null, $file_contents_sanitized);
      
              remove_filter('upload_mimes', [ 'SharedFilesAdminAllowMoreFileTypes', 'add_file_types' ] );
              remove_filter('upload_dir', [$this, 'set_upload_dir']);

              if (isset($upload['error']) && $upload['error']) {
                wp_die('There was an error uploading your file. The error is: ' . $upload['error']);
              }
      
              add_post_meta($id, '_sf_file', $upload);
              update_post_meta($id, '_sf_file', $upload);
      
              $filename = substr(strrchr($upload['file'], "/"), 1);
      
              update_post_meta($id, '_sf_filename', $filename);

              $sf_file_size = 0;
              $upload_file = '';
              
              if ( isset($_FILES['_sf_files']['size'][$i]) && $_FILES['_sf_files']['size'][$i] ) {
                $sf_file_size = sanitize_text_field( $_FILES['_sf_files']['size'][$i] );
              } 
              
              if ( isset($upload['file']) && $upload['file'] ) {
                $upload_file = sanitize_text_field( $upload['file'] );
              }
              
              SharedFilesFileUpdate::uFilesize($id, $sf_file_size, $upload_file);

              update_post_meta($id, '_sf_load_cnt', 0);
              update_post_meta($id, '_sf_bandwidth_usage', 0);
              update_post_meta($id, '_sf_file_added', current_time('Y-m-d H:i:s'));

              update_post_meta($id, '_sf_main_date', '');

              SharedFilesHelpers::addFeaturedImage($id, $upload, $uploaded_type, $filename, 1);
      
              $post_title = preg_replace('/\\.[^.\\s]{3,4}$/', '', $_FILES['_sf_files']['name'][$i]);
      
              $my_post = array(
                'ID'           => $id,
                'post_title'   => sanitize_text_field( $post_title ),
              );
      
              wp_update_post($my_post);
                      
            } else {
              
              $error_msg = esc_html__('A file was not successfully uploaded. Please note the maximum file size.', 'shared_files');
              wp_die($error_msg);
              
            }
          } 
          
          wp_redirect(get_admin_url(null, 'edit.php?post_type=shared_file&_sf_success=1'));
          exit;
    
        }
        
      }      
    }

  }

  public function add_multiple_files_view() {

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {
  
        $screen = get_current_screen();
                
        if ($screen->id == 'edit-shared_file' && $screen->action == '') {
    
          $taxonomy_slug = 'shared-file-category';
    
          ?>
          <script>
          jQuery('.post-type-shared_file .wp-header-end').after(function() {
      
             let sf_button_markup = '<div class="shared-files-multiple-files-upload-container">' + 
                                 '<h2><?= esc_html__('Add multiple files', 'shared-files') ?></h2>' + 
                                 '<form method="post" action="<?= get_admin_url() . 'edit.php?post_type=shared_file' ?>" enctype="multipart/form-data">' + 
                                 '<input type="file" name="_sf_files[]" multiple required><br /><br />' + 
                                 '<label>Category:</label>' + 
    
                                 `<?php
                                  if (get_taxonomy($taxonomy_slug)) {
                              
                                    wp_dropdown_categories([
                                      'show_option_all' => ' ',
                                      'hide_empty' => 0,
                                      'hierarchical' => 1,
                                      'show_count' => 1,
                                      'orderby' => 'name',
                                      'name' => $taxonomy_slug,
                                      'value_field' => 'slug',
                                      'taxonomy' => $taxonomy_slug,
                                    ]);
                                    
                                  }
                                 ?><br /><br />` + 
                                 `<?php wp_nonce_field('sf_insert_multiple_files', 'secret_code') ?>` + 
                                 '<input type="hidden" name="_sf_insert_multiple_files" value="1" />' + 
                                 `<p style="margin-top: 4px; margin-bottom: 0;"><?= esc_html__('Maximum size of uploaded files on one submit:', 'shared-files') ?>` + ' ' + `<strong><?= SharedFilesHelpers::maxUploadSize() ?></strong></p>` +
                                 '<p style="margin-top: 4px; margin-bottom: 20px;"><a href="https://www.sharedfilespro.com/how-to-increase-maximum-media-library-file-upload-size-in-wordpress-3-different-ways/" target="_blank"><?= esc_html__('How to increase the maximum size', 'shared-files') ?> &raquo;</a></p>' +
                                 '<input type="submit" name="submit" value="Upload">' + 
                                 '</form>' + 
                                 '</div>';
      
             return sf_button_markup;
      
          });

          jQuery('.post-type-shared_file .page-title-action').after(function() {
            return '<a href="" class="page-title-action shared-files-add-multiple-files">Add multiple files</div>';
          });

          </script>
    
    
          <?php if (isset($_GET) && isset($_GET['_sf_success']) && !isset($_GET['ids'])): ?>
            <script>
            jQuery('.post-type-shared_file .wp-header-end').after(function() {
               let sf_ok_markup = '<div class="shared-files-multiple-files-added-container"><div class="shared-files-multiple-files-added"><?= esc_html__('File(s) successfully added.', 'shared-files') ?></div></div>';
               return sf_ok_markup;
            });
            </script>
          <?php endif; ?>
    
          <?php
        }

      }
    }

  }

  /**
   * Set the custom upload directory.
   *
   * @since    1.0.0
   */
  public function set_upload_dir($dir) {
  
    $s = get_option('shared_files_settings');
  
    $folder_for_new_files = '';    
  
    if (isset($s['folder_for_new_files']) && $s['folder_for_new_files']) {
      $folder_for_new_files = '/' . sanitize_file_name($s['folder_for_new_files']);
      
      $full_path_new = realpath( $dir['basedir'] ) . '/shared-files' . $folder_for_new_files;
      
      if (!file_exists($full_path_new)) {
        mkdir($full_path_new);
      }
    }
  
    return array(
      'path'   => realpath( $dir['basedir'] ) . '/shared-files' . $folder_for_new_files,
      'url'    => $dir['baseurl'] . '/shared-files' . $folder_for_new_files,
      'subdir' => '/shared-files' . $folder_for_new_files,
    ) + $dir;
  }

}
