<?php

class SharedFilesAdminQuery {

  /**
   * Serve the file itself and update necessary metadata.
   *
   * @since    1.0.0
   */
  public function alter_the_query($request) {

    global $wp;

    $s = get_option('shared_files_settings');

    $url = esc_url_raw( home_url($wp->request) );
    $url_parts = parse_url($url);

    $sf_query = 0;

    if (isset($url_parts['path'])) {
      $path_parts = explode('/', $url_parts['path']);
    }

    if (is_super_admin() && isset($_GET['DEBUG_URL_PARTS'])) {
      echo '<pre>1</pre>';
      echo '<pre>' . esc_html( var_dump( $url_parts ) ) . '</pre>';
      echo '<pre>2</pre>';
      echo '<pre>' . esc_html( var_dump( $path_parts ) ) . '</pre>';
      if (sizeof($path_parts) > 1) {
        echo '<pre>3</pre>';
        echo '<pre>' . var_dump( esc_html( $path_parts[count($path_parts)-2] ) ) . '</pre>';
      }
      echo '<pre>4</pre>';
      echo '<pre>' . var_dump( esc_html( end($path_parts) ) ) . '</pre>';
    }

    $sf_base = '';
    $sf_base_alt = '';
    $sf_file_id = 0;
    $sf_query_filename = '';

    $file_id = 0;
    $sc_part = '';
    $sf_sc = '';

    if (isset($path_parts) && is_array($path_parts) && isset($path_parts[count($path_parts)-3])) {

      $sf_base = $path_parts[count($path_parts)-3];
      $sf_base_alt = $path_parts[count($path_parts)-2];

      if ($sf_base == 'shared-files') {

        if ( isset( $s['obfuscate_file_urls'] ) ) {

          $sc_part = sanitize_text_field( $path_parts[count($path_parts)-2] );
          $sc_parts = explode('-', $sc_part);

          if ( isset( $sc_parts[0] ) && $sc_parts[0] && isset( $sc_parts[1] ) && $sc_parts[1] ) {

            $file_id = $sc_parts[0];
            $sf_sc = $sc_parts[1];
            $sf_query = 1;
            $sf_query_filename = end($path_parts);

          }

        } else {

          $file_id = (int) $path_parts[count($path_parts)-2];

          if ($file_id > 0) {
            $sf_query = 1;
            $sf_query_filename = end($path_parts);
          }

        }

      } elseif ($sf_base_alt == 'shared-files') {

        if ( isset( $s['obfuscate_file_urls'] ) ) {

          $sc_part = sanitize_text_field( end($path_parts) );
          $sc_parts = explode('-', $sc_part);

          if ( isset( $sc_parts[0] ) && $sc_parts[0] && isset( $sc_parts[1] ) && $sc_parts[1] ) {

            $file_id = $sc_parts[0];
            $sf_sc = $sc_parts[1];
            $sf_query = 1;
            $sf_query_filename = end($path_parts);

          }

        } else {

          $file_id = (int) end($path_parts);

          if ($file_id > 0) {
            $sf_query = 1;
            $sf_query_filename = '';
          }

        }

      }

    }

    if (is_super_admin() && isset($_GET['DEBUG_URL_PARTS'])) {
      echo '<pre>sf_base</pre>';
      echo '<pre>' . var_dump( esc_html( $path_parts[count($path_parts)-3] ) ) . '</pre>';
      echo '<pre>sf_base</pre>';
      echo '<pre>' . var_dump( esc_html( $sf_base ) ) . '</pre>';
      echo '<pre>sf_base_alt</pre>';
      echo '<pre>' . var_dump( esc_html( $sf_base_alt ) ) . '</pre>';
      echo '<pre>sf_query</pre>';
      echo '<pre>' . var_dump( esc_html( $sf_query ) ) . '</pre>';
      echo '<pre>file_id</pre>';
      echo '<pre>' . var_dump( esc_html( $file_id ) ) . '</pre>';
      echo '<pre>sf_query_filename</pre>';
      echo '<pre>' . var_dump( esc_html( $sf_query_filename ) ) . '</pre>';
      wp_die();
    }

    $file_id = intval( $file_id );

    if ($sf_query && $file_id) {

      $post_status = get_post_status( $file_id );

      if ( $post_status && $post_status != 'publish' ) {
        $msg = sanitize_text_field( __('File is no longer available.', 'shared-files') );
        wp_die( esc_html( $msg ) );
      }

      if (shared_files_fs()->is__premium_only()) {
        if (shared_files_fs()->can_use_premium_code()) {

          if ( SharedFilesHelpers::isMin3Pr() ) {

            if ( isset( $s['obfuscate_file_urls'] ) ) {

              if ( $sf_sc ) {

                $c = get_post_custom($file_id);

                $sf_file_added = '';
                $sf_filesize = '';

                if ( isset($c['_sf_file_added'][0]) && $c['_sf_file_added'][0] ) {
                  $sf_file_added = sanitize_text_field( $c['_sf_file_added'][0] );
                }

                if ( isset($c['_sf_filesize'][0]) && $c['_sf_filesize'][0] ) {
                  $sf_filesize = sanitize_text_field( $c['_sf_filesize'][0] );
                }

                $sc_calc = md5( $file_id . $sf_file_added . get_option('shared-files-sc') . $sf_filesize );

                if ( $sf_sc != $sc_calc ) {

                  // Wrong code
                  echo 'ERROR';
                  die();

                }

              }

            }

          }

        }
      }

      if ($file_id) {

        if (shared_files_fs()->is__premium_only()) {
          if (shared_files_fs()->can_use_premium_code()) {

            if ( isset($s['file_access_logged_in_only']) && !is_user_logged_in() ) {

              global $wp;

              $wp_request = rtrim($wp->request, '/') . '/';

              $current_url = '';

              if ( isset( $_GET ) ) {
                $current_url = home_url( add_query_arg( $_GET, $wp_request ) );
              } else {
                $current_url = home_url( add_query_arg( [], $wp_request ) );
              }

              $login_url = esc_url_raw( wp_login_url( $current_url ) );

              wp_safe_redirect( $login_url, 302 );

            }

            // START user permission check

            if ( SharedFilesHelpers::isMin2Pr() ) {

              $permission_user_id = sanitize_text_field( get_post_meta($file_id, '_sf_permission_user_id', true) );

              if ( isset($_GET['SF_DEBUG_843']) ) {
                var_dump( $permission_user_id );
                print('<br /><br />');
                var_dump( intval( get_current_user_id() ) );
                print('<br /><br />');
                $current_user_x = wp_get_current_user();
                var_dump($current_user_x);
                print('<br /><br />');
                var_dump($current_user_x->ID);
                print('<br /><br />');
                global $current_user;
                var_dump( $current_user );
                wp_die();
              }

              if ($permission_user_id) {

                $current_user_id = intval( get_current_user_id() );

                $permission_granted = preg_match("/(^|,)" . $current_user_id . "(,|$)/", $permission_user_id );

                if ( !$permission_granted && $permission_user_id != $current_user_id && !is_super_admin() ) {

                  $access_restricted_msg = '<b>' . esc_html__('The access to this file is restricted.') . '</b><br /><br />' . esc_html__('Contact the site administrator for more information (error code 1).', 'shared-files');

                  wp_die( wp_kses_post( $access_restricted_msg ) );

                }

              }

              // END user permission check

              // START role permission check

              $user = wp_get_current_user();
              $logged_in_user_roles = [];

              if ( isset($user->roles) && is_array( $user->roles ) ) {
                $logged_in_user_roles = $user->roles;
              }

              global $wp_roles;

              $roles = $wp_roles->get_names();

              $permission_for_user_roles = [];

              foreach ($roles as $key => $value) {

                if ($key && $value) {

                  $field_name = '_sf_permission_user_role_' . sanitize_title( $key );

                  $checked = intval( get_post_meta($file_id, $field_name, true) );

                  if ($checked) {
                    $permission_for_user_roles []= sanitize_title( $key );
                  }

                }

              }

              if ( isset($_GET['SF_DEBUG_322']) ) {
                var_dump($permission_for_user_roles);
                print('<br /><br />');
                var_dump($logged_in_user_roles);
                wp_die();
              }

              $permission_granted_by_role = 0;

              if ( sizeof($permission_for_user_roles) > 0 && is_array( $logged_in_user_roles ) ) {

                foreach ( $logged_in_user_roles as $role ) {

                  if ( in_array($role, $permission_for_user_roles) ) {
                    $permission_granted_by_role = 1;
                  } elseif ( is_super_admin() ) {
                    $permission_granted_by_role = 1;
                  }

                }

              }

              if ( sizeof($permission_for_user_roles) > 0 && !$permission_granted_by_role ) {

                $access_restricted_msg = '<b>' . esc_html__('The access to this file is restricted.') . '</b><br /><br />' . esc_html__('Contact the site administrator for more information (error code 2).', 'shared-files');

                wp_die( wp_kses_post( $access_restricted_msg ) );

              }

              // END role permission check

            }

          }
        }

        $filesize = 0;

        if (get_post_meta($file_id, '_sf_filesize', true)) {
          $filesize = intval( get_post_meta($file_id, '_sf_filesize', true) );
        }

        if (shared_files_fs()->is__premium_only()) {
          if (shared_files_fs()->can_use_premium_code()) {

            $password = '';

            $cat_password = SharedFilesHelpers::getCatPassword__premium_only($file_id);
            $cat_password_protection_type = SharedFilesHelpers::getCatPasswordProtectionType__premium_only($file_id);
            $file_password = sanitize_text_field( get_post_meta($file_id, '_sf_password', true) );

            if ($file_password) {
              $password = $file_password;
            } elseif ($cat_password) {
              $password = $cat_password;
            }

            $given_password = '';

            if (isset($_POST['password']) && $_POST['password']) {
              $given_password = sanitize_text_field( $_POST['password'] );
            } elseif ($cat_password_protection_type == 'cookie' && isset($_COOKIE['_sf_cat_password']) && $_COOKIE['_sf_cat_password']) {
              $given_password = sanitize_text_field( $_COOKIE['_sf_cat_password'] );
            }

            if ($password && (!$given_password || $given_password != $password)) {
              echo SharedFilesPublicHelpers::passwordProtectedMarkup__premium_only( $file_id );
              die();
            }

            if ( isset( $s['trigger_download_email'] ) && $s['trigger_download_email'] == 'download_button_only' ) {

              if (isset($_GET['se']) && $_GET['se'] == 1) {
                SharedFilesAdminSendMail::file_load_send_email__premium_only($file_id, get_post($file_id));
              }

            } else {
              SharedFilesAdminSendMail::file_load_send_email__premium_only($file_id, get_post($file_id));
            }

            if (isset($_GET['preview'])) {

              $preview_file = get_post_meta($file_id, '_sf_file', true);
              $preview_file_url = esc_url_raw( $preview_file['url'] );

              $preview_redirect_url_parts = parse_url($preview_file_url);
              $preview_file_uri = $preview_redirect_url_parts['path'];

              $preview_full_url = esc_url_raw( get_site_url() ) . $preview_file_uri;

              if (isset($s['preview_service']) && $s['preview_service'] == 'microsoft') {
                $goto_url = 'https://view.officeapps.live.com/op/view.aspx?src=' . urlencode( esc_url( $preview_full_url ) );
              } else {
                $goto_url = 'https://docs.google.com/gview?url=' . urlencode( esc_url( $preview_full_url ) );
              }

              if ($goto_url) {
                wp_redirect($goto_url);
                exit;
              }

            }

          }
        }

        $external_url = esc_url_raw( get_post_meta($file_id, '_sf_external_url', true) );
        $file = get_post_meta($file_id, '_sf_file', true);
        $filename_fallback = get_post_meta($file_id, '_sf_filename', true);

        if ($external_url) {

          if (shared_files_fs()->is__premium_only()) {
            if (shared_files_fs()->can_use_premium_code()) {

              // Update load counter and last access
              $load_cnt = (int) get_post_meta($file_id, '_sf_load_cnt', true);
              $load_limit = (int) get_post_meta($file_id, '_sf_limit_downloads', true);

              if ($load_limit && $load_cnt >= $load_limit) {
                SharedFilesAdminSendMail::file_limit_send_email__premium_only($file_id, get_post($file_id));
                echo SharedFilesPublicHelpers::downloadLimitMarkup__premium_only();
                die();
              }

              update_post_meta($file_id, '_sf_load_cnt', intval( $load_cnt ) + 1);
              update_post_meta($file_id, '_sf_last_access', current_time('Y-m-d H:i:s'));

            }
          }

          if (!isset($_POST['youtube']) && !isset($_POST['only_meta'])) {
            header('Location: ' . esc_url_raw( $external_url ) );
          }

          die();

        } elseif ( $file || $filename_fallback ) {

          $redirect = 0;

          if (isset($s['file_open_method']) && $s['file_open_method'] == 'redirect') {
            $redirect = 1;
          }

          $filename = '';

          if (isset($file['file'])) {

            $filename = SharedFilesFileOpen::getUpdatedPathAndFilename( sanitize_text_field( $file['file'] ) );

          } elseif ( $filename_fallback ) {

            // metadata not found (field _sf_file)

            $filename_with_path_fallback = 'shared-files/';

            if ( $subdir_fallback = get_post_meta($file_id, '_sf_subdir', true) ) {
              $filename_with_path_fallback .= $subdir_fallback . '/';
            }

            $filename_with_path_fallback .= $filename_fallback;

            $filename = SharedFilesFileOpen::getUpdatedPathAndFilename( sanitize_text_field( $filename_with_path_fallback ) );

          }

          if (is_super_admin() && isset($_GET['DEBUG_FILE'])) {
            echo '<pre>' . var_dump( esc_html( $file['file'] ) ) . '</pre>';
            echo '<pre>' . var_dump( esc_html( $filename ) ) . '</pre>';
            echo '<pre>' . var_dump( esc_html( $filename_fallback ) ) . '</pre>';
            wp_die();
          }

          if (!$redirect && (!isset($filename) || !file_exists($filename))) {
            wp_die( esc_html__('File not found:', 'shared-files') . '<br />' . $filename );
          }

          $file_mime = '';

          if (function_exists('mime_content_type')) {
            $file_mime = mime_content_type($filename);
          } elseif (function_exists('finfo_open') && function_exists('finfo_file')) {
            $finfo = finfo_open(FILEINFO_MIME_TYPE);
            $file_mime = finfo_file($finfo, $filename);
            finfo_close($finfo);
          }

          if ( !$file_mime ) {
            $file_mime = SharedFilesAdminHelpers::get_mime_type($filename);
          }

          if ( $file_mime == 'text/html' ) {
            $file_mime = 'text/plain';
          }

          // Update load counter (1/2)
          $load_cnt = (int) get_post_meta($file_id, '_sf_load_cnt', true);

          if (shared_files_fs()->is__premium_only()) {
            if (shared_files_fs()->can_use_premium_code()) {

              // Update last access and bandwidth usage
              $load_limit = (int) get_post_meta($file_id, '_sf_limit_downloads', true);

              if ($load_limit && $load_cnt >= $load_limit) {
                SharedFilesAdminSendMail::file_limit_send_email__premium_only($file_id, get_post($file_id));
                echo SharedFilesPublicHelpers::downloadLimitMarkup__premium_only();
                die();
              }

              update_post_meta($file_id, '_sf_last_access', current_time( 'Y-m-d H:i:s' ));

              $bandwidth_usage = intval( get_post_meta($file_id, '_sf_bandwidth_usage', true) );
              update_post_meta($file_id, '_sf_bandwidth_usage', intval( $bandwidth_usage ) + intval( $filesize ));

            }
          }

          // Update load counter (2/2)
          update_post_meta($file_id, '_sf_load_cnt', intval( $load_cnt ) + 1);

          if ( !isset($s['disable_download_log']) ) {

            global $wpdb;

            $report = '';

            $ip_address = '';

            if ( isset( $s['log_enable_ip'] ) ) {
              $ip_address = sanitize_text_field( SharedFilesHelpers::getIPAddress() );
            }

            $user_agent = '';

            if ( isset( $s['log_enable_user_agent'] ) ) {

              if ( isset( $_SERVER['HTTP_USER_AGENT'] ) ) {
                $user_agent = sanitize_text_field( $_SERVER['HTTP_USER_AGENT'] );
              }

            }

            $referer_url = '';

            if ( isset( $s['log_enable_referer_url'] ) ) {

              if ( isset( $_SERVER['HTTP_REFERER'] ) ) {
                $referer_url = sanitize_text_field( $_SERVER['HTTP_REFERER'] );
              }

            }

            $user_id = 0;
            $user_login = '';
            $user_name = '';
            $user_country = '';

            if ( isset( $s['log_enable_user_data'] ) ) {

              $user_id = intval( get_current_user_id() );

              if ( $user_id ) {

                $user = wp_get_current_user();

                if ( $user ) {

                  $user_fullname = '';

                  if ($user->first_name && $user->last_name) {
                    $user_fullname = $user->first_name . ' ' . $user->last_name;
                  } elseif ($user->last_name) {
                    $user_fullname = $user->last_name;
                  } elseif ($user->first_name) {
                    $user_fullname = $user->first_name;
                  }

                  $user_login = sanitize_text_field( $user->user_login );
                  $user_name = sanitize_text_field( $user_fullname );
                  $user_country = '';

                }

              }

            }

            $wpdb->insert($wpdb->prefix . 'shared_files_download_log', array(
              'file_id'      => intval( $file_id ),
              'file_title'   => sanitize_text_field( get_the_title( $file_id ) ),
              'file_name'    => sanitize_text_field( $filename ),
              'file_size'    => sanitize_text_field( $filesize ),
              'ip'           => $ip_address,
              'download_cnt' => intval( $load_cnt ) + 1,
              'report'       => $report,

              'user_id'      => $user_id,
              'user_login'   => $user_login,
              'user_name'    => $user_name,
              'user_country' => $user_country,
              'user_agent'   => $user_agent,
              'referer_url'  => $referer_url
            ));

          }

          if (isset($s['file_open_method']) && $s['file_open_method'] == 'redirect') {
            $file = get_post_meta($file_id, '_sf_file', true);
            $file_url = esc_url_raw( $file['url'] );

            $redirect_url_parts = parse_url($file_url);
            $file_uri = $redirect_url_parts['path'];

            wp_redirect( esc_url_raw( $file_uri ) );
            exit;
          }

          if (function_exists('ob_start')) {
            ob_start();
          }

          $custom_filename = sanitize_text_field( get_post_meta($file_id, '_sf_filename', true) );

          $header_filename_ext = '';

          if ( $custom_filename ) {

            $header_filename_ext = $custom_filename;

          } else {

            $path = pathinfo($filename);
            $header_filename = $path['filename'];
            $header_extension = $path['extension'];

            if ($header_filename && $header_extension) {
              $header_filename_ext = $header_filename . '.' . $header_extension;
            }

          }

          if (shared_files_fs()->is__premium_only()) {
            if (shared_files_fs()->can_use_premium_code()) {

              $uploaded_by_frontend_uploader = intval( get_post_meta($file_id, '_sf_frontend_uploader', true) );

              if ( $uploaded_by_frontend_uploader && isset($s['prevent_search_engines_from_indexing_uploaded_file_urls']) ) {
                header('X-Robots-Tag: noindex, nofollow', true);
              } elseif ( isset($s['prevent_search_engines_from_indexing_file_urls']) ) {
                header('X-Robots-Tag: noindex, nofollow', true);
              }

            }
          }

          if (isset($_GET['download'])) {

            header('Pragma: public');
            header('Expires: 0');
            header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
            header('Content-Type: application/force-download');
            header('Content-Type: application/octet-stream');
            header('Content-Type: application/download');

            if ($header_filename_ext) {
              header('Content-Disposition: attachment;filename=' . $header_filename_ext);
            }

            header('Content-Transfer-Encoding: binary');

          } else {

            // Set headers
            header('Content-Type: ' . $file_mime);

            if ($header_filename_ext) {
              header('Content-Disposition: inline; filename="' . $header_filename_ext . '"');
            }

            header('Cache-Control: no-cache, must-revalidate');
            header('X-Accel-Buffering: no');

            header('Content-Length: ' . filesize($filename));

          }

          if (isset($s['file_open_method']) && $s['file_open_method'] == 'alt') {

            set_time_limit(0);
            $file_alt = @fopen($filename, 'rb');

            while (!feof($file_alt)) {
              print(@fread($file_alt, 1024 * 8));
              ob_flush();
              flush();
            }

          } else {

            if ( function_exists('ob_get_level') && function_exists('ob_end_clean') ) {
              while ( ob_get_level() ) {
                ob_end_clean();
              }
            }

            if (function_exists('flush')) {
              flush();
            }

            readfile($filename);

          }

          exit;
        }

      }

    }

    return $request;
  }

}
