<?php

class SharedFilesPublicAjax {

  public function sf_get_files() {

    $html = '';

    $tag_slug = '';
    $term_slug = '';
    $atts = [];

    $restricted = 0;

    if ( isset( $_POST['restricted'] ) ) {
      $restricted = intval( $_POST['restricted'] );
    }

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if (isset($_POST['atts'])) {
          $atts = json_decode( str_replace("\\", "", $_POST['atts']), true );
        };

      }
    }

    if (isset($_POST['sf_tag']) && $_POST['sf_tag']) {
      $tag_slug = sanitize_title( $_POST['sf_tag'] );
    }

    if (isset($_POST['sf_category']) && $_POST['sf_category']) {
      $term_slug = sanitize_title( $_POST['sf_category'] );
    } elseif (isset($atts['category']) && $atts['category']) {
      $term_slug = sanitize_title( $atts['category'] );
    }

    $cf_active = 0;

    $meta_query = [];

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        $meta_query = array('relation' => 'AND');

        $custom_fields_cnt = 3 + 1;

        if (isset($s['custom_fields_cnt'])) {
          $custom_fields_cnt = intval( $s['custom_fields_cnt'] ) + 1;
        } else {
          $custom_fields_cnt = 5 + 1;
        }

        for ($n = 1; $n < $custom_fields_cnt; $n++) {

          $field_name = 'cf_' . $n;

          if (isset($_POST[$field_name]) && $_POST[$field_name]) {

            $meta_query[] = array(
              'key'		  => '_sf_file_upload_cf_' . $n,
              'value'		=> sanitize_text_field( $_POST[$field_name] ),
              'compare'	=> '='
            );

            $cf_active = 1;

          }

        }

      }
    }

    if (isset($atts['hide_files_first']) && !$term_slug && !$tag_slug && !$cf_active) {
      die();
    }

    /* CATEGORY PASSWORD START */
    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {
        if (isset($term_slug) && $term_slug) {

          $password_check_markup = SharedFilesPublicHelpers::checkCatPassword__premium_only($term_slug, 1);

          if ($password_check_markup) {
            $html .= $password_check_markup;
            echo $html;
            die();
          }

        }
      }
    }
    /* CATEGORY PASSWORD END */

    $meta_query_hide_not_public = array('relation' => 'OR');

    $meta_query_hide_not_public[] = array(
			'key'		  => '_sf_not_public',
			'compare'	=> '=',
			'value'   => ''
		);

    $meta_query_hide_not_public[] = array(
			'key'		  => '_sf_not_public',
			'compare'	=> 'NOT EXISTS',
		);

    $meta_query_full = array('relation' => 'AND');

    $meta_query_full []= $meta_query_hide_not_public;
    $meta_query_full []= $meta_query;

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if ( $restricted ) {

          $meta_query_permissions = SharedFilesShortcodePermissions::setPermissionsAjax();

          $meta_query_full = array('relation' => 'AND');
          $meta_query_full []= $meta_query;
          $meta_query_full []= $meta_query_permissions;

        }

      }
    }

    $tax_query = ['relation' => 'AND'];

    if ($tag_slug) {

      $tax_query []= array(
        'taxonomy'          => SHARED_FILES_TAG_SLUG,
        'field'             => 'slug',
        'terms'             => $tag_slug,
      );

    }

    if ($term_slug) {

      $tax_query []= array(
        'taxonomy'          => 'shared-file-category',
        'field'             => 'slug',
        'terms'             => $term_slug,
        'include_children'  => true
      );

      $wp_query = new WP_Query(array(
        'post_type'       => 'shared_file',
        'post_status'     => 'publish',
        'posts_per_page'  => -1,

        'tax_query'       => $tax_query,

        'orderby'     => SharedFilesHelpers::getOrderBy($atts),
        'order'       => SharedFilesHelpers::getOrder($atts),
        'meta_key'    => SharedFilesHelpers::getMetaKey($atts),

        'meta_query'  => $meta_query_full,
      ));

    } else {

      $wp_query = new WP_Query(array(
        'post_type'       => 'shared_file',
        'post_status'     => 'publish',
        'posts_per_page'  => -1,

        'tax_query'       => $tax_query,

        'orderby'         => SharedFilesHelpers::getOrderBy($atts),
        'order'           => SharedFilesHelpers::getOrder($atts),
        'meta_key'        => SharedFilesHelpers::getMetaKey($atts),

        'meta_query'      => $meta_query_full,
      ));

    }

    $hide_description = isset($_POST['hide_description']) && $_POST['hide_description'] ? 1 : '';

    if ($wp_query->have_posts()):
      while ($wp_query->have_posts()): $wp_query->the_post();

        $id = intval( get_the_id() );
        $c = get_post_custom($id);

        $external_url = isset($c['_sf_external_url']) ? esc_url_raw( $c['_sf_external_url'][0] ) : '';
        $filetype = '';

        $imagefile = SharedFilesHelpers::getImageFile($id, $external_url);

        $html .= SharedFilesPublicFileCardDefault::fileListItem($c, $imagefile, $hide_description, 1, $atts);

      endwhile;
    endif;

    if ($wp_query->found_posts == 0) {
      $html .= '<p>' . sanitize_text_field( __('No files found.', 'shared-files') ) . '</p>';
    }

    $html_allowed_tags = [

      'li' => [
      ],

      'div' => [
        'class' => [],
        'style' => []
      ],

      'a' => [
        'href' => [],
        'target' => [],
        'data-file-url' => [],
        'data-external-url' => [],
        'data-image-url' => [],
        'data-file-type' => [],

        'data-tag-slug' => [],
        'data-hide-description' => [],

        'data-file-id' => [],

        'class' => [],
        'id' => [],
        'download' => [],
        'onclick' => [],
      ],

      'span' => [
        'class' => []
      ],

      'img' => [
        'src' => []
      ],

      'b' => [
      ],

      'p' => [
      ],

    ];

    echo wp_kses($html, $html_allowed_tags);

  }

  public function sf_get_files_simple__premium_only() {

    $html = '';

    $tag_slug = '';
    $term_slug = '';
    $atts = [];

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if (isset($_POST['atts'])) {
          $atts = json_decode( str_replace("\\", "", $_POST['atts']), true );
        };

      }
    }

    if (isset($_POST['sf_tag']) && $_POST['sf_tag']) {
      $tag_slug = sanitize_title( $_POST['sf_tag'] );
    }

    if (isset($_POST['sf_category']) && $_POST['sf_category']) {
      $term_slug = sanitize_title( $_POST['sf_category'] );
    } elseif (isset($atts['category']) && $atts['category']) {
      $term_slug = sanitize_title( $atts['category'] );
    }

    $cf_active = 0;

    $meta_query = [];

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        $meta_query = array('relation' => 'AND');

        $custom_fields_cnt = 3 + 1;

        if (isset($s['custom_fields_cnt'])) {
          $custom_fields_cnt = intval( $s['custom_fields_cnt'] ) + 1;
        } else {
          $custom_fields_cnt = 5 + 1;
        }

        for ($n = 1; $n < $custom_fields_cnt; $n++) {

          $field_name = 'cf_' . $n;

          if (isset($_POST[$field_name]) && $_POST[$field_name]) {

            $meta_query[] = array(
              'key'		  => '_sf_file_upload_cf_' . $n,
              'value'		=> sanitize_text_field( $_POST[$field_name] ),
              'compare'	=> '='
            );

            $cf_active = 1;

          }

        }

      }
    }

    if (isset($atts['hide_files_first']) && !$term_slug && !$tag_slug && !$cf_active) {
      die();
    }

    /* CATEGORY PASSWORD START */
    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {
        if (isset($term_slug) && $term_slug) {

          $password_check_markup = SharedFilesPublicHelpers::checkCatPassword__premium_only($term_slug, 1);

          if ($password_check_markup) {
            $html .= $password_check_markup;
            echo $html;
            die();
          }

        }
      }
    }
    /* CATEGORY PASSWORD END */

    $meta_query_hide_not_public = array('relation' => 'OR');

    $meta_query_hide_not_public[] = array(
      'key'		  => '_sf_not_public',
      'compare'	=> '=',
      'value'   => ''
    );

    $meta_query_hide_not_public[] = array(
      'key'		  => '_sf_not_public',
      'compare'	=> 'NOT EXISTS',
    );

    $meta_query_full = array('relation' => 'AND');

    $meta_query_full []= $meta_query_hide_not_public;
    $meta_query_full []= $meta_query;

    $tax_query = ['relation' => 'AND'];

    if ($tag_slug) {

      $tax_query []= array(
        'taxonomy'          => SHARED_FILES_TAG_SLUG,
        'field'             => 'slug',
        'terms'             => $tag_slug,
      );

    }

    if ($term_slug) {

      $tax_query []= array(
        'taxonomy'          => 'shared-file-category',
        'field'             => 'slug',
        'terms'             => $term_slug,
        'include_children'  => true
      );

      $wp_query = new WP_Query(array(
        'post_type'       => 'shared_file',
        'post_status'     => 'publish',
        'posts_per_page'  => -1,

        'tax_query'       => $tax_query,

        'orderby'     => SharedFilesHelpers::getOrderBy($atts),
        'order'       => SharedFilesHelpers::getOrder($atts),
        'meta_key'    => SharedFilesHelpers::getMetaKey($atts),

        'meta_query'  => $meta_query_full,
      ));

    } else {

      $wp_query = new WP_Query(array(
        'post_type'       => 'shared_file',
        'post_status'     => 'publish',
        'posts_per_page'  => -1,

        'tax_query'       => $tax_query,

        'orderby'         => SharedFilesHelpers::getOrderBy($atts),
        'order'           => SharedFilesHelpers::getOrder($atts),
        'meta_key'        => SharedFilesHelpers::getMetaKey($atts),

        'meta_query'      => $meta_query_full,
      ));

    }

    $hide_description = isset($_POST['hide_description']) && $_POST['hide_description'] ? 1 : '';

    if ($wp_query->have_posts()) {
      $html .= SharedFilesPublicHelpers::SharedFilesSimpleMarkup($wp_query, 0, $atts);
    }

    if ($wp_query->found_posts == 0) {
      $html .= '<p>' . sanitize_text_field( __('No files found.', 'shared-files') ) . '</p>';
    }

    $html_allowed_tags = [

      'li' => [
      ],

      'div' => [
        'class' => [],
        'style' => []
      ],

      'a' => [
        'href' => [],
        'target' => [],
        'data-file-url' => [],
        'data-external-url' => [],
        'data-image-url' => [],
        'data-file-type' => [],

        'data-tag-slug' => [],
        'data-hide-description' => [],

        'data-file-id' => [],

        'class' => [],
        'id' => [],
        'download' => [],
        'onclick' => [],
      ],

      'span' => [
        'class' => []
      ],

      'img' => [
        'src' => []
      ],

      'b' => [
      ],

      'p' => [
      ],

    ];

    echo wp_kses($html, $html_allowed_tags);

  }

  public function add_to_favorites__premium_only() {

    $s = get_option('shared_files_settings');

    if ( is_user_logged_in() && !isset( $s['activate_favorite_files_for_logged_in'] ) ) {
      die();
    }

    if ( !is_user_logged_in() && !isset( $s['activate_favorite_files_for_non_logged_in'] ) ) {
      die();
    }

    $user_id = intval( get_current_user_id() );
    $file_id = intval( $_POST['file_id'] );

    $current_favorites = '';

    if (is_user_logged_in()) {

      $current_favorites = sanitize_text_field( get_user_meta( $user_id, 'shared_files_favorite_files', true ) );

    } elseif ( isset( $_COOKIE['shared_files_favorite_files'] ) ) {

      $current_favorites = sanitize_text_field( $_COOKIE['shared_files_favorite_files'] );

    }

//    $current_favorites = '';

    $current_favorites_arr = [];

    if ($current_favorites) {
      $current_favorites_arr = explode( ',', $current_favorites );
    }

    if (sizeof($current_favorites_arr) == 1 && ( $current_favorites_arr[0] == '0' || $current_favorites_arr[0] == '1' || $current_favorites_arr[0] == '' ) ) {
      $current_favorites_arr = [];
    }

    if ( !in_array( $file_id, $current_favorites_arr ) ) {

      $current_favorites_arr []= intval( $file_id );

    }

    $updated_favorites_str = '';

    if ( sizeof($current_favorites_arr) > 1 ) {
      $updated_favorites_str = implode( ',', $current_favorites_arr );
    } elseif ( sizeof($current_favorites_arr) == 1 ) {
      $updated_favorites_str = intval( $current_favorites_arr[0] );
    }

    if (is_user_logged_in()) {

      update_user_meta( $user_id, 'shared_files_favorite_files', $updated_favorites_str );

    } else {

      $expiry = strtotime('+1 month');

      setcookie('shared_files_favorite_files', $updated_favorites_str, $expiry, '/');

    }

    $html_allowed_tags = [

      'span' => [
        'class' => []
      ],

    ];

//    echo wp_kses($html, $html_allowed_tags);

    echo '<span class="shared-files-favorited">&#9733; ' . SharedFilesHelpers::getText( 'favorite_files_text_favorited', __('Favorited', 'shared-files') ) . '</span>';

  }

  public function delete_from_favorites__premium_only() {

    $s = get_option('shared_files_settings');

    if ( is_user_logged_in() && !isset( $s['activate_favorite_files_for_logged_in'] ) ) {
      die();
    }

    if ( !is_user_logged_in() && !isset( $s['activate_favorite_files_for_non_logged_in'] ) ) {
      die();
    }

    $user_id = intval( get_current_user_id() );
    $file_id = intval( $_POST['file_id'] );

    $current_favorites = '';

    if (is_user_logged_in()) {

      $current_favorites = sanitize_text_field( get_user_meta( $user_id, 'shared_files_favorite_files', true ) );

    } elseif ( isset( $_COOKIE['shared_files_favorite_files'] ) ) {

      $current_favorites = sanitize_text_field( $_COOKIE['shared_files_favorite_files'] );

    }

  //    $current_favorites = '';

    $current_favorites_arr = [];

    if ($current_favorites) {
      $current_favorites_arr = explode( ',', $current_favorites );
    }

    if ( ( $key = array_search($file_id, $current_favorites_arr)) !== false ) {
      unset( $current_favorites_arr[$key] );
      $current_favorites_arr = array_values( $current_favorites_arr );
    }

    $updated_favorites_str = '';

    if ( sizeof($current_favorites_arr) > 1 ) {
      $updated_favorites_str = implode( ',', $current_favorites_arr );
    } elseif ( sizeof($current_favorites_arr) == 1 ) {
      $updated_favorites_str = intval( $current_favorites_arr[0] );
    }

    if (is_user_logged_in()) {

      update_user_meta( $user_id, 'shared_files_favorite_files', $updated_favorites_str );

    } else {

      $expiry = strtotime('+1 month');

      setcookie('shared_files_favorite_files', $updated_favorites_str, $expiry, '/');

    }

    echo '<span class="shared-files-favorite-removed">&#9733; ' . SharedFilesHelpers::getText( 'favorite_files_text_deleted', __('Removed', 'shared-files') ) . '</span>';

  }

}
