<?php

class SharedFilesPublicHelpers {

  public static function proFeaturePublicMarkup() {

    $html = '';

    $html .= '<div class="shared-files-public-pro-feature">';
    $html .= '<span class="shared-files-public-pro-feature-title">';
    $html .= sanitize_text_field( __('This feature is available in the paid plans.', 'shared-files') );
    $html .= '</span>';
    $html .= '<span>';
    $html .= sanitize_text_field( __('You can use the shortcodes', 'shared-files') . ' [shared_files] ' . __('and', 'shared-files') . ' [shared_files_simple].' );
    $html .= '</span>';
    $html .= '<span>';
    $html .= sanitize_text_field( __('More info on shortcodes', 'shared-files') . ' <a href="' . esc_url( get_admin_url(null, 'edit.php?post_type=shared_file&page=shared-files-shortcodes' ) ) . '" target="_blank">here</a>.' );
    $html .= '</span>';
    $html .= '</div>';

    return $html;

  }

  public static function getDescription( $c, $s ) {

    $html = '';

    if (isset($s['textarea_for_file_description']) && $s['textarea_for_file_description']) {
      $html .= '<div class="shared-file-description-container">' . wp_kses_post( nl2br($c['_sf_description'][0]) ) . '</div>';
    } else {
      $html .= '<div class="shared-file-description-container">' . wp_kses_post( $c['_sf_description'][0] ) . '</div>';
    }

    return $html;

  }

  public static function checkCatPassword__premium_only($term_slug, $return_markup) {

    $html = '';

    $parent_cat = get_term_by('slug', $term_slug, 'shared-file-category');

    $cat_password = '';
    $cat_password_protection_type = '';

    if ( $parent_cat instanceof WP_Term ) {
      $cat_password = SharedFilesTermMetadata::get_hierarchichal_term_metadata($parent_cat, '_sf_cat_password');
      $cat_password_protection_type = SharedFilesTermMetadata::get_hierarchichal_term_metadata($parent_cat, '_sf_cat_password_protection_type');
    }

    $file_list_is_password_protected = 0;

    if ($cat_password_protection_type == 'cookie') {
      $file_list_is_password_protected = 1;
    }

    $given_password = '';

    if (isset($_POST['_sf_cat_password']) && $_POST['_sf_cat_password']) {
      $given_password = sanitize_text_field( $_POST['_sf_cat_password'] );
    } else if ($cat_password_protection_type == 'cookie' && isset($_COOKIE['_sf_cat_password']) && $_COOKIE['_sf_cat_password']) {
      $given_password = sanitize_text_field( $_COOKIE['_sf_cat_password'] );
    }

    if ($file_list_is_password_protected && (!$given_password || $given_password != $cat_password)) {

      if ($return_markup) {
        $html = SharedFilesPublicHelpers::passwordProtectedMarkupForFileList__premium_only();
      } else {
        echo SharedFilesPublicHelpers::passwordProtectedMarkupForFileList__premium_only();
        die();
      }

    }

    if ($return_markup) {
      return $html;
    }

  }

  public static function listCategories__premium_only($categories) {

    $html = '';

    $html .= '<div class="shared-files-categories-container">';

    $html .= '<div class="shared-files-categories">';

    $html .= '<ul class="shared-files-categories-list">';

    foreach ($categories as $cat):

      $html .= '<li>';
        $html .= '<div>';
          $html .= '<a href="?cat=' . esc_attr( $cat->slug ) . '">' . sanitize_text_field( $cat->name ) . '</a>';
        $html .= '</div>';
      $html .= '</li>';

    endforeach;

    $html .= '</ul>';

    $html .= '</div>';

    $html .= '</div>';

    return $html;

  }

  public static function getFileURL($file_id = 0, $download = 0, $force_direct_url = 0, $atts = []) {

    $file_id = intval( $file_id );

    $s = get_option('shared_files_settings');

    $c = get_post_custom($file_id);

    $file_url = '';

    if (isset($c['_sf_filename'])) {

      $obfuscated = 0;

      if (shared_files_fs()->is__premium_only()) {
        if (shared_files_fs()->can_use_premium_code()) {

          if ( shared_files_fs()->is_plan_or_trial('business') ) {

            if ( isset($s['obfuscate_file_urls']) ) {

              $sf_file_added = '';
              $sf_filesize = '';

              if ( isset($c['_sf_file_added'][0]) && $c['_sf_file_added'][0] ) {
                $sf_file_added = $c['_sf_file_added'][0];
              }

              if ( isset($c['_sf_filesize'][0]) && $c['_sf_filesize'][0] ) {
                $sf_filesize = $c['_sf_filesize'][0];
              }

              $sc_part = $file_id . '-' . md5( $file_id . $sf_file_added . get_option('shared-files-sc') . $sf_filesize );

              $file_url = SharedFilesHelpers::sf_root() . '/shared-files/' . $sc_part . '/' . SharedFilesHelpers::wp_engine() . sanitize_text_field( $c['_sf_filename'][0] );

              $obfuscated = 1;

            }

          }

        }
      }

      if ( !$obfuscated ) {

        $file_url = SharedFilesHelpers::sf_root() . '/shared-files/' . $file_id . '/' . SharedFilesHelpers::wp_engine() . sanitize_text_field( $c['_sf_filename'][0] );

      }

      if ($download && SharedFilesHelpers::wp_engine()) {
        $file_url .= '&download=1';
      } elseif ($download) {
        $file_url .= '?download=1';
      }

      if (shared_files_fs()->is__premium_only()) {
        if (shared_files_fs()->can_use_premium_code()) {

          if ( $download && isset( $s['trigger_download_email'] ) && $s['trigger_download_email'] == 'download_button_only' ) {

            $query = parse_url($file_url, PHP_URL_QUERY);

            // Returns a string if the URL has parameters or NULL if not
            if ($query) {
              // ??????????????
              $file_url .= '&se=1';
            } else {
              $file_url .= '?se=1';
            }

          }

        }
      }

    }

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if ( shared_files_fs()->is_plan_or_trial('business') ) {

          // Wait page is active, force url to wait page
          if ( ( isset( $s['activate_wait_page'] ) || isset( $atts['use_wait_page'] ) ) && isset( $s['wait_page'] ) && $s['wait_page'] && !$force_direct_url ) {

            $wait_page_id = intval( $s['wait_page'] );
            $wait_page_url = esc_url_raw( get_permalink( $wait_page_id ) );

            if ( $wait_page_id > 0 && $wait_page_url) {
              $file_url = add_query_arg('sf_file_id', $file_id, $wait_page_url);
            }

          }

        }

      }
    }

    return $file_url;
  }

  public static function getFileType($file_id = 0) {

    $file_id = intval( $file_id );

    $c = get_post_custom($file_id);

    $file = get_post_meta($file_id, '_sf_file', true);

    $file_type = '';
    $file_ext = '';

    $external_url = isset($c['_sf_external_url']) ? esc_url_raw( $c['_sf_external_url'][0] ) : '';

    if ($external_url && (substr($external_url, 0, strlen('https://www.youtube.com')) === 'https://www.youtube.com' || substr($external_url, 0, strlen('https://youtu.be')) === 'https://youtu.be')) {

      $file_type = 'youtube';

    } elseif (isset($file['file'])) {

      $file_ext = pathinfo( sanitize_text_field( $file['file'] ), PATHINFO_EXTENSION);

      switch ($file_ext) {

        case 'jpg';
        case 'jpeg';
        case 'jpe';
        case 'png';
        case 'gif';
        case 'webp';
        case 'avif';
          $file_type = 'image';
          break;
        case 'mp4';
        case 'webm';
        case 'ogg';
        case 'mov';
          $file_type = 'video/' . sanitize_text_field( $file_ext );
          break;

      }

    }

    return $file_type;
  }

  public static function limitActive($file_id) {

    $file_id = intval( $file_id );

    $load_cnt = (int) get_post_meta($file_id, '_sf_load_cnt', true);
    $load_limit = (int) get_post_meta($file_id, '_sf_limit_downloads', true);
    $limit_active = 0;

    if ($load_limit && $load_cnt >= $load_limit) {
      $limit_active = 1;
    }

    return $limit_active;

  }

  public static function addToFavoritesButton__premium_only($file_id, $atts = []) {

    $html = '';

    if ( shared_files_fs()->is_plan_or_trial('business') ) {

      if ( isset($atts['hide_favorites']) ) {
        $html = '';
        return $html;
      }

      $s = get_option('shared_files_settings');

      if ( is_user_logged_in() && !isset( $s['activate_favorite_files_for_logged_in'] ) ) {
        return '';
      }

      if ( !is_user_logged_in() && !isset( $s['activate_favorite_files_for_non_logged_in'] ) ) {
        return '';
      }

      $user_id = intval( get_current_user_id() );
      $file_id = intval( $file_id );

      $current_favorites = '';
      $current_favorites_arr = [];

      if (is_user_logged_in()) {

        $current_favorites = sanitize_text_field( get_user_meta( $user_id, 'shared_files_favorite_files', true ) );
        $current_favorites_arr = explode( ',', $current_favorites );

      } elseif ( isset( $_COOKIE['shared_files_favorite_files'] ) ) {

        $current_favorites = sanitize_text_field( $_COOKIE['shared_files_favorite_files'] );
        $current_favorites_arr = explode( ',', $current_favorites );

      }

      $html .= '<hr class="clear" />';

      if ( in_array( $file_id, $current_favorites_arr ) ) {
        $html .= '<div class="shared-files-add-to-favorites-container shared-files-is-favorited">';
        $html .= '<span class="shared-files-favorited">&#9733; ' . SharedFilesHelpers::getText( 'favorite_files_text_favorited', __('Favorited', 'shared-files') ) . '</span>';
        $html .= '<a href="" class="shared-files-delete-from-favorites" data-file-id="' . intval( $file_id ) . '">&#9733; ' . SharedFilesHelpers::getText( 'favorite_files_text_delete_from_favorites', __('Remove from favorites', 'shared-files') ) . '</a>';
        $html .= '</div>';

      } else {
        $html .= '<div class="shared-files-add-to-favorites-container"><a href="" class="shared-files-add-to-favorites" data-file-id="' . intval( $file_id ) . '">&#9734; ' . SharedFilesHelpers::getText( 'favorite_files_text_add_to_favorites', __('Add to favorites', 'shared-files') ) . '</a></div>';
      }

    }

    return $html;

  }

  public static function editFileButton__premium_only($file_id) {

    $file_id = intval( $file_id );

    $s = get_option('shared_files_settings');

    $can_edit_files = 0;

    $html = '';

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if (!is_user_logged_in()) {
          return '';
        }

        $user = wp_get_current_user();
        $roles = (array) $user->roles;

        foreach ($roles as $role) {

          $setting = 'can_edit_files_' . $role;

          if (isset($s[$setting])) {
            $can_edit_files = 1;
          }

        }

        if (!$can_edit_files) {
          return '';
        }

        if (!function_exists('wp_terms_checklist')) {
          include_once ABSPATH . 'wp-admin/includes/template.php';
        }

        $html .= '<hr class="clear" />';

        $html .= '<a href="" class="shared-files-edit-file" data-file-id="' . intval( $file_id ) . '">' . sanitize_text_field( __('Edit', 'shared-files') ) . '</a>';

      }
    }

    return $html;

  }

  public static function editFileModal__premium_only($file_id, $current_url = '') {

    $file_id = intval( $file_id );

    $s = get_option('shared_files_settings');

    $can_edit_files = 0;

    $html = '';

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if (!is_user_logged_in()) {
          return '';
        }

        $user = wp_get_current_user();
        $roles = (array) $user->roles;

        foreach ($roles as $role) {

          $setting = 'can_edit_files_' . $role;

          if (isset($s[$setting])) {
            $can_edit_files = 1;
          }

        }

        if (!$can_edit_files) {
          return '';
        }

        if (!function_exists('wp_terms_checklist')) {
          include_once ABSPATH . 'wp-admin/includes/template.php';
        }

        $html .= '<hr class="clear" />';

        $html .= '<div class="shared-files-modal-container shared-files-modal-container-edit-file shared-files-modal-container-' . $file_id . ' shared-files-modal-container-edit-file-' . $file_id . '" data-file-id="' . $file_id . '">';
        $html .= '<div class="shared-files-modal shared-files-modal-edit-file">';

        $html .= '<div class="shared-files-close-modal-container">';
        $html .= '<a href="" class="shared-files-close-modal" data-file-id="' . $file_id . '">&#10006;</a>';
        $html .= '</div>';



 //       $html .= '<div id="edit-file-' . $file_id . '" class="shared-files-edit-single-file">';

        $html .= '<form method="post" enctype="multipart/form-data">';

        $html .= wp_nonce_field('sf_update_file', 'secret_code', true, false);

        $html .= '<input name="_sf_file_id" value="' . $file_id . '" type="hidden" />';

        $html .= '<input name="shared-files-update-file" value="1" type="hidden" />';

        $goto_url = $current_url;

        if ( !$goto_url ) {

          if ( isset($_SERVER['REQUEST_URI']) ) {
            $request_uri = explode('?', $_SERVER['REQUEST_URI']);

            if ( isset($request_uri[0]) ) {
              $goto_url = $request_uri[0];
            }
          }

        }

        $html .= '<input name="_SF_GOTO" type="hidden" style="width: 100%;" value="' . esc_url( $goto_url ) . '" />';

        $html .= '<span class="shared-files-single-file-title">' . esc_html__('Title', 'shared-files') . '</span>';
        $html .= '<input type="text" name="_sf_title" class="shared-files-title" value="' . esc_attr( get_the_title() ) . '" />';

        $html .= '<span class="shared-files-single-file-title">' . esc_html__('Replace with a new file', 'shared-files') . '</span>';
        $html .= '<input type="file" id="sf_file" name="_sf_file" size="25" /><hr class="clear" />';

        $external_url = get_post_meta($file_id, '_sf_external_url', true);

        if ( !isset($s['file_edit_hide_external_url']) ) {

          $html .= '<span class="shared-files-single-file-title">' . esc_html__('External URL', 'shared-files') . '</span>';
          $html .= '<input type="text" name="_sf_external_url" class="shared-files-title" value="' . esc_attr( $external_url ) . '" />';

        }

        if ( !isset($s['file_edit_hide_category_checkboxes']) ) {

          $html .= '<span class="shared-files-single-file-title">' . esc_html__('Categories', 'shared-files') . '</span>';

          $taxonomy_slug = 'shared-file-category';
          $term_ids = [];

          if ( $terms = get_the_terms( $file_id, $taxonomy_slug ) ) {
            $term_ids = wp_list_pluck( $terms, 'term_id' );
          }

          $termlist_args = [
                            'taxonomy' => $taxonomy_slug,
                            'echo' => 0,
                            'selected_cats' => $term_ids,
                            'checked_ontop' => false
                           ];

          $html .= '<ul class="sf-termlist">' . wp_terms_checklist(0, $termlist_args) . '</ul>';

        }

        if ( !isset($s['file_edit_hide_new_categories']) ) {

          $html .= '<span class="shared-files-single-file-title">' . esc_html__('New categories', 'shared-files') . '</span><p>' . esc_html__('A comma separated list of any new categories.', 'shared-files') . '</p>';

          $html .= '<input type="text" name="_SF_NEW_CATEGORIES" class="shared-files-title" value="" />';

        }

        if ( !isset($s['file_edit_hide_tag_checkboxes']) ) {

          $html .= '<span class="shared-files-single-file-title">' . esc_html__('Tags', 'shared-files') . '</span>';

          $tag_slug = SHARED_FILES_TAG_SLUG;
          $tag_ids = [];

          if ( $terms = get_the_terms( $file_id, $tag_slug ) ) {
            $tag_ids = wp_list_pluck( $terms, 'term_id' );
          }

          $taglist_args = [
                            'taxonomy' => $tag_slug,
                            'echo' => 0,
                            'selected_cats' => $tag_ids,
                            'checked_ontop' => false
                          ];

          $html .= '<ul class="sf-taglist">' . wp_terms_checklist(0, $taglist_args) . '</ul>';

        }

        if ( !isset($s['file_edit_hide_new_tags']) ) {

          $html .= '<span class="shared-files-single-file-title">' . esc_html__('New tags', 'shared-files') . '</span><p>' . esc_html__('A comma separated list of any new tags.', 'shared-files') . '</p>';

          $html .= '<input type="text" name="_SF_NEW_TAGS" class="shared-files-title" value="" />';

        }

        if ( !isset($s['file_edit_hide_description']) ) {

          $description = get_post_meta($file_id, '_sf_description', true);

          $html .= '<span class="shared-files-single-file-title">' . esc_html__('Description', 'shared-files') . '</span>';

          $description_class = 'shared-files-description-editor shared-files-description-editor-file-' . $file_id;

          if (isset($s['textarea_for_file_description']) && $s['textarea_for_file_description']) {
            $description_class = 'shared-files-description-editor';
          }

          $html .= '<textarea name="_sf_description" id="shared-files-editor-' . $file_id . '" class="' . $description_class . '">' . wp_kses_post( $description ) . '</textarea>';

        }

        $html .= '<hr class="clear" /><input style="margin-top: 20px;" type="submit" value="' . esc_html__('Update', 'shared-files') . '" class="sf-public-file-update-submit" />';

        $html .= '</form>';

        $html .= '<div class="shared-files-delete-file-container">';

        $html .= '<span class="shared-files-single-file-title">' . esc_html__('Delete file', 'shared-files') . '</span>';

        $user = wp_get_current_user();

        $bare_url = './?_sf_delete_editable_file=' . $file_id;

        $html .= '<a href="' . wp_nonce_url($bare_url, '_sf_delete_editable_file_' . intval( $user->ID ), 'sc') . '" id="shared-files-public-delete-file" class="shared-files-public-delete-file" onclick="return confirm(\'' . esc_attr__('Are you sure?', 'shared-files') . '\')">' . esc_html__('Delete', 'shared-files') . '</a>';

        $html .= '</div>';

//        $html .= '</div>';


        $html .= '</div>';
        $html .= '</div>';


      }
    }

    return $html;

  }

  public static function passwordProtectedMarkupForFileList__premium_only() {

    $html = '';

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        $html .= '<div class="shared-files-password-protected-container">';
        $html .= '<div class="shared-files-password-protected">';

        $html .= '<form method="POST" action="">';

        $html .= '<h2>' . esc_html__('Please enter password', 'shared-files') . '</h2>';

      //    $html .= wp_nonce_field('_CL_UPDATE', '_wpnonce', true, false);

        $html .= '<div class="form-field">';
        $html .=   '<div class="form-field-left"><label for="password">' . esc_html__('Password', 'shared-files') . '</label></div>';
        $html .=   '<div class="form-field-right"><input type="password" name="_sf_cat_password" id="password" value="" /></div>';
        $html .= '</div>';

        $html .= '<hr class="clear" />';

        if (isset($_POST) && isset($_POST['_sf_cat_password'])) {
          $html .=   '<div class="shared-files-invalid-password">' . esc_html__('Invalid password', 'shared-files') . '</div>';
        }

        $html .= '<input type="submit" class="shared-files-form-submit" value="' . esc_html__('Submit', 'shared-files') . '" />';

        $html .= '</form>';

        $html .= '</div>';
        $html .= '</div>';

      }
    }

    return $html;

  }

  public static function passwordProtectedMarkup__premium_only( $file_id ) {

    $html = '';

    $file_title = sanitize_text_field( get_the_title( $file_id ) );
    $filename = sanitize_text_field( get_post_meta( $file_id, '_sf_filename', true) );

    $html .= '<html>';
//    $html .= '<html lang="en-US">';
  	$html .= '<head>';
  	$html .= '<meta charset="UTF-8">';
  	$html .= '<meta name="viewport" content="width=device-width, initial-scale=1.0">';
  	$html .= '<link rel="profile" href="https://gmpg.org/xfn/11">';
  	$html .= '<title>' . esc_html__('File:', 'shared-files') . ' ' . $filename . '</title>';
    $html .= '</head>';
    $html .= '<body>';

    $html .='
  <style>

    body {
      background: #f7f7f7;
      font-family: "Quattrocento", serif;
    }

    h1 {
      margin-top: 5px;
      font-size: 24px;
      font-family: "Oswald", sans-serif;
      font-size: 24px;
      text-transform: uppercase;
    }

    .shared-files-password-protected-container {
      margin-top: 80px;
    }

    .shared-files-invalid-password {
      margin: 5px 0 20px 0;
      padding: 10px;
      color: crimson;
      border: 1px solid crimson;
      text-align: center;
      clear: both;
      font-family: "Oswald", sans-serif;
      text-transform: uppercase;
    }

    .shared-files-password-protected {
      max-width: 440px;
      margin: 0 auto;
      background: #fff;
      padding: 40px 30px;
      border: 1px solid #ccc;
      border-radius: 3px;
    }

    .shared-files-password-protected .form-field .form-field-left {
      width: 40%;
      float: left;
      min-height: 40px;
    }

    .shared-files-password-protected .form-field .form-field-left label {
      padding-top: 3px;
      display: inline-block;
    }

    .shared-files-password-protected .form-field .form-field-right {
      width: 60%;
      float: left;
      min-height: 40px;
    }

    .shared-files-password-protected .form-field .form-field-right input {
      width: 100%;
      padding: 5px;
      border: none;
      background: #f7f7f7;
      border: 1px solid #ccc;
    }

    .shared-files-form-submit {
      color: #fff;
      text-transform: uppercase;
      text-decoration: none;
      background: #333;
      padding: 10px 40px;
      display: inline-block;
      transition: all 0.4s ease 0s;
      cursor: pointer;
      font-size: 16px;
      margin-bottom: 20px;
      font-weight: bold;
      border: none;
      margin-top: 10px;
    }

    .shared-files-form-submit:hover {
      background: #000;
      transition: all 0.4s ease 0s;
    }

    @media (max-width: 500px) {

      .shared-files-password-protected .form-field .form-field-left {
        width: 100%;
        float: none;
        min-height: auto;
        margin-bottom: 5px;
      }

      .shared-files-password-protected .form-field .form-field-right {
        width: 100%;
        float: none;
        margin-bottom: 8px;
      }

    }

  </style>
    ';

    $html .= '<link href="https://fonts.googleapis.com/css?family=Oswald|Quattrocento" rel="stylesheet">';

    $html .= '<form method="POST" action="">';

    $html .= '<div class="shared-files-password-protected-container">';
    $html .= '<div class="shared-files-password-protected">';

    $html .= '<h1>' . esc_html__('Please enter password', 'shared-files') . '</h1>';

    $html .= '<div class="form-field">';
    $html .=   '<div class="form-field-left"><label for="password">' . esc_html__('Password', 'shared-files') . '</label></div>';
    $html .=   '<div class="form-field-right"><input type="password" name="password" id="password" value="" /></div>';
    $html .= '</div>';

    if (isset($_POST) && $_POST) {
      $html .=   '<div class="shared-files-invalid-password">' . esc_html__('Invalid password', 'shared-files') . '</div>';
    }

    $html .= '<input type="submit" class="shared-files-form-submit" value="' . esc_attr__('Submit', 'shared-files') . '" />';
    $html .= '</form>';

    $html .= '</body>';
    $html .= '</html>';

    return $html;

  }

  public static function downloadLimitMarkup__premium_only() {

    $html = '';

    // for ......

    $html .= '<html lang="en-US">';
  	$html .= '<head>';
  	$html .= '<meta charset="UTF-8">';
  	$html .= '<meta name="viewport" content="width=device-width, initial-scale=1.0">';
  	$html .= '<link rel="profile" href="https://gmpg.org/xfn/11">';
  	$html .= '<title>' . esc_html__('Download limit reached:', 'shared-files') . '</title>';
    $html .= '<link href="https://fonts.googleapis.com/css?family=Oswald|Quattrocento" rel="stylesheet">';
    $html .= '</head>';
    $html .= '<body>';

    $html .='
  <style>

    body {
      background: #f7f7f7;
      font-family: "Quattrocento", serif;
    }

    h1 {
      margin-top: 5px;
      font-size: 24px;
      font-family: "Oswald", sans-serif;
      font-size: 24px;
      text-transform: uppercase;
    }

    .shared-files-password-protected-container {
      margin-top: 80px;
    }

    .shared-files-invalid-password {
      margin: 5px 0 20px 0;
      padding: 10px;
      color: crimson;
      border: 1px solid crimson;
      text-align: center;
      clear: both;
      font-family: "Oswald", sans-serif;
      text-transform: uppercase;
    }

    .shared-files-password-protected {
      max-width: 440px;
      margin: 0 auto;
      background: #fff;
      padding: 40px 30px;
      border: 1px solid #ccc;
      border-radius: 3px;
      color: #000;
    }

    .shared-files-password-protected a {
      color: #000;
    }

    .shared-files-password-protected .form-field .form-field-left {
      width: 40%;
      float: left;
      min-height: 40px;
    }

    .shared-files-password-protected .form-field .form-field-left label {
      padding-top: 3px;
      display: inline-block;
    }

    .shared-files-password-protected .form-field .form-field-right {
      width: 60%;
      float: left;
      min-height: 40px;
    }

    .shared-files-password-protected .form-field .form-field-right input {
      width: 100%;
      padding: 5px;
      border: none;
      background: #f7f7f7;
      border: 1px solid #ccc;
    }

    .shared-files-form-submit {
      color: #fff;
      text-transform: uppercase;
      text-decoration: none;
      background: #333;
      padding: 10px 40px;
      display: inline-block;
      transition: all 0.4s ease 0s;
      cursor: pointer;
      font-size: 16px;
      margin-bottom: 20px;
      font-weight: bold;
      border: none;
      margin-top: 10px;
    }

    .shared-files-form-submit:hover {
      background: #000;
      transition: all 0.4s ease 0s;
    }

    @media (max-width: 500px) {

      .shared-files-password-protected .form-field .form-field-left {
        width: 100%;
        float: none;
        min-height: auto;
        margin-bottom: 5px;
      }

      .shared-files-password-protected .form-field .form-field-right {
        width: 100%;
        float: none;
        margin-bottom: 8px;
      }

    }

  </style>
    ';

    $s = get_option('shared_files_settings');

    $html .= '<div class="shared-files-password-protected-container">';
    $html .= '<div class="shared-files-password-protected">';

    $html .= '<h1>' . esc_html__('Download limit reached', 'shared-files') . '</h1>';

    if (isset($s['download_limit_msg']) && $s['download_limit_msg']) {

      $str = $s['download_limit_msg'];

      $str = preg_replace(
              '@(https?://([-\w\.]+[-\w])+(:\d+)?(/([\w/_\.#-~]*(\?\S+)?)?)?)@',
              '<a href="$1">$1</a>', $str);

      $html .= '<p>' . nl2br($str) . '</p>';
    } else {
      $html .= '<p>' . esc_html__('This file is no longer available for download.', 'shared-files') . '</p>';
    }

    $html .= '</body>';
    $html .= '</html>';

    return $html;

  }

  public static function sharedFilesSimpleMarkup($wp_query, $include_children = 0, $atts = []) {

    $s = get_option('shared_files_settings');

    $html = '';

    $html .= '<div class="shared-files-search">';

    $html .= '<div class="shared-files-simple-list shared-files-ajax-list">';

    if ( isset($s['simple_list_show_titles_for_columns']) ) {
      $html .= SharedFilesPublicHelpers::singleFileSimpleTitlesMarkup($atts);
    }

    if ($wp_query->have_posts()):

      while ($wp_query->have_posts()): $wp_query->the_post();

        $id = intval( get_the_id() );
        $html .= SharedFilesPublicHelpers::singleFileSimpleMarkup($id, 0, $atts);

      endwhile;
    endif;

    $html .= '</div><hr class="clear" />';

    $html .= '</div>';

    wp_reset_postdata();

    return $html;

  }

  public static function singleFileSimpleTitlesMarkup($atts = []) {

    $s = get_option('shared_files_settings');

    $html = '';

    $html .= '<div class="shared-files-simple-list-row shared-files-simple-list-title-row">';

    $html .=  '<div class="shared-files-simple-list-col shared-files-simple-list-col-name shared-files-simple-list-col-title"><span>' .
              SharedFilesHelpers::getText('simple_list_title_file', __('File', 'shared-files')) .
              '</span></div>';

    if (isset($s['simple_list_show_download_counter'])) {
      $html .= '<div class="shared-files-simple-list-col shared-files-simple-list-col-title"><span>';
      $html .= SharedFilesHelpers::getText('simple_list_title_download_counter', __('Downloads', 'shared-files'));
      $html .= '</span></div>';
    }

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        $custom_fields_cnt = 3 + 1;

        if (isset($s['custom_fields_cnt'])) {
          $custom_fields_cnt = intval( $s['custom_fields_cnt'] ) + 1;
        } else {
          $custom_fields_cnt = 5 + 1;
        }

        for ($n = 1; $n < $custom_fields_cnt; $n++) {

          if (isset($s['simple_list_show_custom_field_' . $n])) {

            $html .= '<div class="shared-files-simple-list-col shared-files-simple-list-col-title"><span>';

            $cf_field_title = sanitize_text_field( __('Custom field', 'shared-files') . ' ' . $n );

            if ( isset($s['simple_list_title_custom_field_' . $n]) && $s['simple_list_title_custom_field_' . $n] ) {

              $cf_field_title = sanitize_text_field( $s['simple_list_title_custom_field_' . $n] );

            } elseif (isset($s['file_upload_custom_field_' . $n]) && $cf_title = sanitize_text_field( $s['file_upload_custom_field_' . $n] )) {

              $cf_field_title = $cf_title;

            }

            $html .= sanitize_text_field( $cf_field_title );

            $html .= '</span></div>';

          }

        }

      }
    }

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if (isset($s['simple_list_show_category'])) {

          $html .= '<div class="shared-files-simple-list-col shared-files-simple-list-col-title"><span>';
          $html .= SharedFilesHelpers::getText('simple_list_title_category', __('Category', 'shared-files'));
          $html .= '</span></div>';

        }

      }
    }

    if (isset($s['simple_list_show_tag'])) {

      $html .= '<div class="shared-files-simple-list-col shared-files-simple-list-col-title"><span>';
      $html .= SharedFilesHelpers::getText('simple_list_title_tag', __('Tag', 'shared-files'));
      $html .= '</span></div>';

    }

    $html .= '</div>';

    return $html;

  }

  public static function singleFileSimpleMarkup($id, $showGroups = 0, $atts = []) {

    $id = intval( $id );

    $s = get_option('shared_files_settings');
    $c = get_post_custom($id);

    $file_id = intval( get_the_id() );
    $password = get_post_meta($file_id, '_sf_password', true);
    $external_url = isset($c['_sf_external_url']) ? esc_url_raw( $c['_sf_external_url'][0] ) : '';

    $html = '';

    $html .= '<div class="shared-files-simple-list-row">';

    $html .= '<div class="shared-files-simple-list-col shared-files-simple-list-col-name"><span>';

//    $file_url = (isset($c['_sf_filename']) ? SharedFilesHelpers::sf_root() . '/shared-files/' . intval( get_the_id() ) . '/' . SharedFilesHelpers::wp_engine() . sanitize_text_field( $c['_sf_filename'][0] ) : '');

    $file_url = SharedFilesPublicHelpers::getFileURL($file_id);

    $data_file_type = '';
    $data_file_url = '';
    $data_video_url_redir = '';
    $data_external_url = '';
    $data_image_url = '';

    if (!$password && !SharedFilesPublicHelpers::limitActive($file_id)) {

      $this_file_type = SharedFilesPublicHelpers::getFileType($file_id);

      $data_file_type = ' data-file-type="' . esc_attr( self::getFileType($file_id) ) . '" ';
      $data_file_url = ' data-file-url="' . esc_url_raw( self::getFileURL($file_id) ) . '" ';
      $data_external_url = ' data-external-url="' . esc_url_raw( $external_url ) . '" ';
      $data_image_url = ' data-image-url="' . esc_url_raw( get_the_post_thumbnail_url($file_id, 'large') ) . '" ';

      if (isset($s['file_open_method']) && $s['file_open_method'] == 'redirect') {

        if ( substr($this_file_type, 0, strlen('video')) === 'video' ) {

          $file_uri = SharedFilesFileOpen::getRedirectTarget( $file_id );

          $data_video_url_redir = ' data-video-url-redir="' . esc_url_raw( $file_uri ) . '" ';

        }

      }

    }

    $html .= '<a class="shared-files-file-title" ' .
      $data_file_type .
      $data_file_url .
      $data_video_url_redir .
      $data_external_url .
      $data_image_url .
      'href="' . $file_url . '" target="_blank">' . sanitize_text_field( get_the_title() ) . '</a>';

    if (isset($c['_sf_filesize']) && !isset($s['hide_file_size_from_card'])) {
      $html .= '<span class="shared-file-size">' . SharedFilesAdminHelpers::human_filesize( sanitize_text_field( $c['_sf_filesize'][0] ) ) . '</span>';
    }

    $html .= SharedFilesHelpers::getPreviewButton($id, $file_url);


    if ( !isset($s['simple_list_hide_file_description']) ) {

      if ( isset($c['_sf_description']) ) {

        if (isset($s['textarea_for_file_description']) && $s['textarea_for_file_description'] && isset($c['_sf_description'][0]) && $c['_sf_description'][0]) {
          $html .= '<p>' . wp_kses_post( nl2br($c['_sf_description'][0]) ) . '</p>';
        } else {
          $html .= wp_kses_post( $c['_sf_description'][0] );
        }

      }

    }

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if (is_user_logged_in() && isset($atts['edit'])) {
          $html .= '<div style="height: 8px;"></div>' . SharedFilesPublicHelpers::editFileButton__premium_only($id);
        }

      }
    }

    $html .= '</span></div>';

    if (isset($s['simple_list_show_download_counter'])) {

      $html .= '<div class="shared-files-simple-list-col shared-files-simple-list-col-download-counter"><span>';

      $html .= intval( get_post_meta($file_id, '_sf_load_cnt', true) );

      $html .= '</span></div>';

    }

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        $custom_fields_cnt = 3 + 1;

        if (isset($s['custom_fields_cnt'])) {
          $custom_fields_cnt = intval( $s['custom_fields_cnt'] ) + 1;
        } else {
          $custom_fields_cnt = 5 + 1;
        }

        for ($n = 1; $n < $custom_fields_cnt; $n++) {

          if (isset($s['simple_list_show_custom_field_' . $n])) {

            $html .= '<div class="shared-files-simple-list-col"><span>';

            if ( isset($s['file_upload_custom_field_' . $n]) ) {

              if (isset($c['_sf_file_upload_cf_' . $n]) && $c['_sf_file_upload_cf_' . $n]) {
                $html .= sanitize_text_field( $c['_sf_file_upload_cf_' . $n][0] );
              }

            }

            $html .= '</span></div>';

          }

        }

      }
    }

    if (shared_files_fs()->is__premium_only()) {
      if (shared_files_fs()->can_use_premium_code()) {

        if (isset($s['simple_list_show_category'])) {

          $html .= '<div class="shared-files-simple-list-col"><span>';

          $terms = get_the_terms($id, 'shared-file-category');

          if ($terms) {

            $html .= '<div class="shared-files-simple-categories">';

            foreach ($terms as $term) {

              $t_id = intval( $term->term_id );
              $custom_fields = get_option("taxonomy_term_$t_id");

              if (!isset($custom_fields['hide_group'])) {
                $html .=  '<span>' . sanitize_text_field( $term->name ) . '</span>';
              }

            }

            $html .= '</div>';

          }

          $html .= '</span></div>';

        }

      }
    }

    if (isset($s['simple_list_show_tag'])) {

      $html .= '<div class="shared-files-simple-list-col"><span>';

      $terms = get_the_terms($id, SHARED_FILES_TAG_SLUG);

      if ($terms) {

        $html .= '<div class="shared-files-simple-tags">';

        foreach ($terms as $term) {

          $t_id = intval( $term->term_id );
          $custom_fields = get_option("taxonomy_term_$t_id");

          if (!isset($custom_fields['hide_group'])) {
            $html .=  '<span>' . sanitize_text_field( $term->name ) . '</span>';
          }

        }

        $html .= '</div>';

      }

      $html .= '</span></div>';

    }

    // row END
    $html .= '</div>';

    return $html;

  }

}
