<?php

class SharedFilesShortcodePermissions {

  public static function setPermissions( $className ) {

    if ( !class_exists($className) || !method_exists($className, 'setFilePermissions') ) {
      wp_die( 'Error in ' . esc_html( $className ) );
    }

    $logged_in_user_id = intval( get_current_user_id() );
    $user = wp_get_current_user();
    $user_roles = $user->roles;

    $meta_query_file_permissions = array('relation' => 'OR');

    $meta_query_file_permissions []= array(
      'key'		  => '_sf_permission_user_id',
      'compare'	=> 'REGEXP',
      'value'   => "(^|,)$logged_in_user_id(,|$)"
    );

    if ( $user_roles && is_array($user_roles) ) {

      foreach ( $user_roles as $logged_in_user_role ) {

        $meta_query_file_permissions []= array(
          'key'		  => '_sf_permission_user_role_' . sanitize_title( $logged_in_user_role ),
          'compare'	=> '=',
          'value'   => 1
        );

      }

    }

    $className::setFilePermissions( $meta_query_file_permissions );

  }

  public static function setPermissionsAjax() {

    $logged_in_user_id = intval( get_current_user_id() );
    $user = wp_get_current_user();
    $user_roles = $user->roles;

    $meta_query_file_permissions = array('relation' => 'OR');

    $meta_query_file_permissions []= array(
      'key'		  => '_sf_permission_user_id',
      'compare'	=> 'REGEXP',
      'value'   => "(^|,)$logged_in_user_id(,|$)"
    );

    if ( $user_roles && is_array($user_roles) ) {

      foreach ( $user_roles as $logged_in_user_role ) {

        $meta_query_file_permissions []= array(
          'key'		  => '_sf_permission_user_role_' . sanitize_title( $logged_in_user_role ),
          'compare'	=> '=',
          'value'   => 1
        );

      }

    }

    return $meta_query_file_permissions;

  }

}
