<?php

class SharedFilesSingleFilePage {

  public static function markup_for_the_content($content) {

    $html = '';

    $s = get_option('shared_files_settings');
    $current_page_id = intval( get_the_ID() );
    $post_type = get_post_type();

    if ( $post_type == 'shared_file' && $current_page_id ) {

      remove_filter( 'the_content', 'wpautop' );

      $html .= '<div class="shared-files-single-file-page-container">';

      $html .= '<div class="shared-files-single-file-page-go-back"><a href="javascript:history.go(-1);">&laquo; ' . esc_html__('Back', 'shared-files')  . '</a></div>';

      $file_id = $current_page_id;
      $atts = [];

      $elem_class = SharedFilesHelpers::createElemClass();

      $c = get_post_custom($file_id);

      $external_url = isset($c['_sf_external_url']) ? esc_url_raw( $c['_sf_external_url'][0] ) : '';
      $filetype = '';

      $imagefile = SharedFilesHelpers::getImageFile($file_id, $external_url);
      $hide_description = '';

      $html .= '<div class="' . $elem_class . ' shared-files-main-container" data-elem-class="' . $elem_class . '">';

      $html .= '<div class="shared-files-search">';
      $html .= '<ul class="shared-files-main-file-list">';

      $html .= SharedFilesPublicFileCardDefault::fileListItem($c, $imagefile, $hide_description, 2, $atts);

      $html .= '</ul>';
      $html .= '</div>';

      // .shared-files-main-container
      $html .= '</div>';

      // .shared-files-single-file-page-container
      $html .= '</div>';

    }

    $html .= $content;

    return $html;

  }

}
