<?php

class SharedFilesPublicWaitPage {

  public static function markup_for_the_content($content) {

    $html = '';

    $s = get_option('shared_files_settings');
    $wait_page_id = 0;
    $current_page_id = intval( get_the_ID() );

    if ( isset( $s['wait_page'] ) && $s['wait_page'] ) {
      $wait_page_id = intval( $s['wait_page'] );
    }

    if ( $current_page_id == $wait_page_id && isset($_GET['sf_file_id']) && $_GET['sf_file_id'] ) {

      remove_filter( 'the_content', 'wpautop' );

      $file_id = intval( $_GET['sf_file_id'] );

      if ( isset($s['wait_page_countdown_seconds']) && $s['wait_page_countdown_seconds'] ) {
        $countdown_length = intval( $s['wait_page_countdown_seconds'] );
      } else {
        $countdown_length = 5;
      }

      if ( $countdown_length <= 0 ) {
        $countdown_length = 5;
      }

      $password = '';
      $cat_password = '';
      $file_password = '';

      $cat_password = SharedFilesHelpers::getCatPassword__premium_only($file_id);
      $file_password = sanitize_text_field( get_post_meta($file_id, '_sf_password', true) );

      if ($file_password) {
        $password = $file_password;
      } elseif ($cat_password) {
        $password = $cat_password;
      }

      $download_button_container_class = '';

      if ( isset($s['wait_page_hide_download_button']) ) {
        $download_button_container_class = 'shared-files-wait-page-download-button-is-hidden';
      }

      $download_attr = 'download';

      if ( isset($s['disable_download_attr']) ) {
        $download_attr = '';
      }

      $html .= '<div class="shared-files-wait-page-dialog">';

      $html .= '<p>' . SharedFilesHelpers::getText( 'wait_page_text_before_seconds', __('Your download will start automatically in', 'shared-files') ) . ' <span class="shared-files-countdown-timer">' . $countdown_length . '</span> ' . SharedFilesHelpers::getText( 'wait_page_text_after_seconds', __('seconds...', 'shared-files') ) . '</p>';

      $html .= '<div class="shared-files-wait-page-download-button-container ' . $download_button_container_class . '"><a id="shared-files-wait-page-download-button" href="' . esc_url_raw( SharedFilesPublicHelpers::getFileURL($file_id, 1, 1) ) . '" ' .  $download_attr . '>' . SharedFilesHelpers::getText( 'wait_page_download_button_text', __('Download', 'shared-files') ) . '</a></div>';

      $html .= '</div>';

      $open_file_js = '';

      if ($password) {
        $open_file_js = 'window.location.href = "' . esc_url_raw( SharedFilesPublicHelpers::getFileURL($file_id, 0, 1) ) . '"';
      } else {
//          $open_file_js = 'jQuery(".shared-files-wait-page-download-button").get(0).click();';
        $open_file_js = 'document.getElementById("shared-files-wait-page-download-button").click();';
      }

      $html .= '
      <script>
      function sharedFilesStartTimer(duration, display) {

        var timer = duration, seconds;

        myInterval = setInterval(function () {

          seconds = parseInt(timer % 60, 10);

          display.textContent = seconds;

          if (--timer < 0) {
            clearInterval(myInterval);
            ' . $open_file_js . '
          }

        }, 1000);

      }
      </script>
      ';

      $html .= "
      <script>
        window.onload = function () {
            var sharedFilesCountdownLength = " . intval( $countdown_length - 1 ) . ",
                display = document.querySelector('.shared-files-countdown-timer');
            sharedFilesStartTimer(sharedFilesCountdownLength, display);
        };
      </script>";

    }

    $html .= $content;

    return $html;

  }

}
